package es12;

/**
 * C.d.L. Informatica
 * Sapienza Universita' di Roma
 * Corso di Metodologie di Programmazione
 * 
 * Prova Scritta del 17/06/2009
 * 
 * Esercizio 2 - 2 parte
 * 
 * Coppie di floating point
 * 
 * @author Stefano Guerrini 
 * @version Aprile 2009
 */
public class FCoppia implements Cloneable
{
    final private float x, y;     // valori della coppia

    /**
     * Costruisce la coppia (0,0)
     */
    public FCoppia() { this(0, 0); }

    /**
     * Costruisce una nuova coppia dai valori a e b
     * 
     * @param a     primo elemento della coppia
     * @param b     secondo elemento della coppia
     */
    public FCoppia(float a, float b) { x = a; y = b; }

    /**
     * Restituisce il primo elemento della coppia
     * 
     * @return      il primo elemento della coppia
     */
    public float fst() { return x; }

    /**
     * Restituisce il secondo elemento della coppia
     * 
     * @return      il secondo elemento della coppia
     */
    public float snd() { return y; }
    
    /**
     * Clonazione di una coppia
     * 
     * @return      la nuova coppia
     */
    public Object clone() { return new FCoppia(x, y); }
}
