package es3;

/**
 * C.d.L. Informatica
 * Sapienza Universita' di Roma
 * Corso di Metodologie di Programmazione
 * 
 * Prova Scritta del 17/06/2009
 * 
 * Esercizio 3 - 2 parte
 * 
 * Implementazione di una coppia per memorizzare oggetti di un tipo generico
 * e una molteplicita' (un valore intero positivo)
 * 
 * @author Stefano Guerrini 
 * @version Aprile 2009
 */
public class Coppia<T>
{
    // componenti della coppia
    final private T t;        // il valore
    final private int i;      // la molteplicita'

    /**
     * Costruttore
     * 
     * @param t     il valore
     * @param i     la molteplicita'
     */
    public Coppia(T t, int i) { this.t = t; this.i = i; }

    /**
     * Restituisce il valore della coppia
     * 
     * @return     il valore 
     */
    public T getVal() { return t; }

    /**
     * Restituisce la molteplicita' (numero di occorrenze) del valore
     * 
     * @return     la molteplicita' 
     */
    public int getOcc() { return i; }

    /**
     * Ridefinizione di equals.
     * Equivalenza tra valori con molteplicita'
     * 
     * @param c     coppia da confrontare con l'istanza
     * @return      true se valori e moltplicita' sono uguali
     */
    public boolean equals(Coppia<T> c) { 
        return (t.equals(c.getVal()) && i == c.getOcc());
    }

    /**
     * Ridefinizione di hashCode.
     * 
     * @return      hashCode pari alla somma della molteplita' e 
     *              dell'hashcode del valore
     */
    public int hashCode() { return (t.hashCode() + i); }
}
