package es3;

import java.util.Set;
import java.util.HashSet;

/**
 * C.d.L. Informatica
 * Sapienza Universita' di Roma
 * Corso di Metodologie di Programmazione
 * 
 * Prova Scritta del 17/06/2009
 * 
 * Esercizio 3 - 2 parte
 * 
 * Classe che contiene il metodo richiesto dall'esercizio
 * 
 * @author Stefano Guerrini 
 * @version Aprile 2009
 */
public class Test
{
    /**
     * Conta la molteplicita' (il numero di occorrenze) degli oggetti
     * di un multinsieme
     * 
     * @param  multi        multinsieme
     * @return              insieme degli elementi nel multinsieme con
     *                      la corrispondente molteplicita' (restituiti
     *                      come coppie valore, molteplicita')
     */
    public <T> Set<Coppia<T>> contaOcc(Multiset<T> multi)
    {
        Set<Coppia<T>> set = new HashSet<Coppia<T>>();
        
        for (T t : multi) {     // scandise tutti gli elementi del multinsieme
            boolean b = false; 
            for (Coppia<T> c : set) {       // verifica se elemento gia' trovato
                if (t.equals(c.getVal())) { // e inserito nell'insieme
                    b = true;   // gia' trovato
                    break;      // termina scansione
                }
            }
            if (! b) {      // se non trovato aggiungi al risultato con la
                            // corrispondente molteplicita'
                set.add(new Coppia(t,multi.getQuantity(t)));
            }
        }
        return set;
    }
}
